<?php
/**
 * Lunarhotel Websitetodo
 * 
 * @package    Lunarhotel Websitetodo
 * @subpackage Components
 * @link http://www.lunarhotel.co.uk
 * @license		GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');


class WebsiteTodoController extends JController
{
	/**
	 * Method to display the view
	 *
	 * @access	public
	 */
	function display()
	{
		parent::display();
	}
	
	function __construct($config = array())
	{
		parent::__construct($config);
		//die(JRequest::getVar("task"));
		// Register Extra tasks
		$this->registerTask( 'apply', 	'save'  );
	}
	
	function publish() {
		$cid = JRequest::getVar( "cid" );
		$model = $this->getModel();
		$model->setPublishedState( $cid, true );
		$this->setRedirect( "index.php?option=com_websitetodo" );
	}
	
	function unpublish() {
		$cid = JRequest::getVar( "cid" );
		$model = $this->getModel();
		$model->setPublishedState( $cid, false );
		$this->setRedirect( "index.php?option=com_websitetodo" );
	}
	
	function complete() {
		$cid = JRequest::getVar( "cid" );
		$model = $this->getModel();
		$model->setCompletedState( $cid, true );
		
		if( JRequest::getVar("source",false)=="module") {
			$this->setRedirect( "index.php" );
		} else {
			$this->setRedirect( "index.php?option=com_websitetodo" );
		}
	}
	
	function incomplete() {
		$cid = JRequest::getVar( "cid" );
		$model = $this->getModel();
		$model->setCompletedState( $cid, false );
		
		if( JRequest::getVar("source",false)=="module") {
			$this->setRedirect( "index.php" );
		} else {
			$this->setRedirect( "index.php?option=com_websitetodo" );
		}
	}
	
	function save() {
		// get the contents of the post variable
		$post=JRequest::get("POST");

		$user = &JFactory::getUser();

		JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR . DS . "tables");
		$table = JTable::getInstance("websitetodo","Table");
		
		if($post['id']) {
			// we're editing, so load the task instance into the table object
			$table->load( $post['id'] );
		}
		//die(print_r($post));
		// now set the new data
		$table->details = $post['details'];
		$table->complete = $post['completed'];
		if( $post['completed'] ) {
			$table->completedby = $user->get('id');
		} else {
			$table->completedby = 0;
		}
		
		$table->publish( $post['id'], $post['published'], $user->get('id') ) ;
		
		$table->store();
		$task = JRequest::getCmd("task");
		if($task == "save") {
			$this->setRedirect( "index.php?option=com_websitetodo" );
		} else if($task == "apply" ) {
			$this->setRedirect( "index.php?option=com_websitetodo&view=task&id=" . $post['id']);
		}
	}
	
	// save param will call apply param, and then redirect to the tasks list
	function saveparam() {
		$this->applyparam();
		$this->setRedirect( "index.php?option=com_websitetodo" );
	}
	
	//save the parameters
	function applyparam() {

		$post=JRequest::get("post");
		$params = &JComponentHelper::getParams( 'com_websitetodo' );

		
		$params->set("showWhen"			,$post['showWhen']		);
		$params->set("userId"			,$post['userId']		);
		$params->set("showComplete"		,$post['showComplete']	);
		$params->set("showUnPublish"	,$post['showUnPublish']	);
		$params->set("enableModules"	,$post['enableModules']	);
		$params->set("enableContent"	,$post['enableContent']	);
		
		$this->setRedirect( "index.php?option=com_websitetodo&view=parameters" );
		
		if(!$params->getParams()){
			die("yeo uits false");
		}
		$db =& JFactory::getDBO();
		$q="update #__components set params=\"" . $paramvalue . "\" where option=\"com_websitetodo\"";
		$db->setQuery($q);
		$db->query();
	}
	
	function remove() {
		$cid = JRequest::getVar( "cid" );
		$model = $this->getModel();
		$model->deleteTask( $cid );
		$this->setRedirect( "index.php?option=com_websitetodo" );
	}
	
	function edit() {
		$cid = JRequest::getVar( "cid" );
		$id=Array_pop($cid);
		$this->setRedirect( "index.php?option=com_websitetodo&view=task&id=" . $id);
	}

}