<?php
/**
* @version		$Id: view.html.php 19343 2010-11-03 18:12:02Z ian $
* @package		Joomla
* @subpackage	Users
* @copyright	Copyright (C) www.lunarhotel.co.uk
* @license		GNU/GPL, see LICENSE.php
*
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the Users component
 *
 * @static
 * @package		Lunarhotel website to do
  */
class WebsitetodoViewWebsitetodo extends JView
{
	function display($tpl = null)
	{
		
		global $mainframe, $option;
		
		$db =& JFactory::getDBO();
		
		// get the filter order, if it exists.
		$order="id";
		$direction="";
		
		$order		= $mainframe->getUserStateFromRequest( "$option.filter_order",		'filter_order',		'id',	'cmd' );
		$direction	= $mainframe->getUserStateFromRequest( "$option.filter_order_Dir",	'filter_order_Dir',	'',		'word' );
		$search		= $mainframe->getUserStateFromRequest( "$option.search",			'search', 			'',		'string');
		$filter_type= $mainframe->getUserStateFromRequest( "$option.filter_type",		'filter_type', 		0,			'string' );
		
		$limit		= $mainframe->getUserStateFromRequest( "global.list.limit", 		'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart = $mainframe->getUserStateFromRequest( "$option.limitstart",		'limitstart', 0, 'int' );
		
		// will need to put the sort field, and order direction into the template
		$lists['order_Dir']	= $direction;
		$lists['order']		= $order;
		$lists['search']	= $search;
		$lists['filter_type'] = $filter_type;
		
		// now update the task item title, so we can sort / filter on it if required
		
		$this->updateTaskDetails();
		
		// then carry on with selecting the data needed by the user
		
		// first get the total number of records
		$q="SELECT count(id) FROM #__wstd_tasklist";
		$db->setQuery( $q );
		$total= $db->loadResult();
		
		// the pagination stuff
		jimport('joomla.html.pagination');
		$pagination = new JPagination( $total, $limitstart, $limit );
		
		// now lets get the actuall list, but using the pagination results.
		
		$q="SELECT id,taskdate,published, details,user,extension,itemtitle" . 
			",complete,extensionid, completedby FROM #__wstd_tasklist where id>0";
		
		if( $lists['search'] ) {
			$q.=" and details like \"%" . $lists['search'] . "%\"";
		}
		
		if ( $lists['filter_type'] ) {
			$q.=" and extension=\"" . $lists['filter_type'] . "\"";
		}
		
		$q.=" order by " . $order . " " . $direction;
		
		$db->setQuery( $q, $pagination->limitstart, $pagination->limit );
		$tasks = $db->loadObjectList();
		
		// list of page elements (modules / content items / pages etc..)
		$elements=Array("com_modules" => "Modules", "com_content" => "Content items", "page" => "Pages");
		
		$types[] 		= JHTML::_('select.option',  '0', '- '. JText::_( 'Select Extension' ) .' -' );
		foreach( $elements as $key => $element ) {
			$types[] = JHTML::_('select.option',  $key, JText::_( $element ) );
		}
		$lists['type'] 	= JHTML::_('select.genericlist',   $types, 'filter_type', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', "$filter_type" );
		
		// now define the submenu items
		/*$smtasks="index.php?option=com_websitetodo";
		$smparameters="index.php?option=com_websitetodo&view=parameters";*/
		
		/*JSubMenuHelper::addEntry( JText::_("Tasks"), $smtasks, JRequest::getVar("task", false));
		JSubMenuHelper::addEntry( JText::_("Parameters"), $smparameters, !JRequest::getCmd("view")=="parameters");*/
		
		JToolBarHelper::preferences( 'com_websitetodo', "280" );	

		
		
		// add the supporting js
		$document = JFactory::getDocument();
	
		$document->addStyleSheet (JURI::root() . "plugins/system/websitetodo/wstd-styles.css");
		$document->addScript (JURI::root() . "/administrator/components/com_websitetodo/assets/websitetodo.js");
		

		$this->assignRef( "tasks", $tasks);
		$this->assignRef("lists", $lists);
		$this->assignRef("pagination", $pagination);
		parent::display($tpl);
	}
	
	/* to allow for the module / content / item title to appear in the task list, we need to copy the item
	title into the task table. This means we can filter, and sort on that field, where as if we linked to it
	we couldnt easily..(everytime a new component / extension support was added, the resulting query qould become
	exponentially more complex) so this function will run everytime the list is generated (in the back end)
	and update the itemtitle field to the relavent text.
	*/
	function updateTaskDetails() {
		
		$q="select * from #__wstd_tasklist";
		
		$db =& JFactory::getDBO();
		
		$db->setQuery( $q );
		
		$tasks=$db->loadObjectList();
		
		foreach($tasks as $task) {
			// check the extension setting & see which we need to link to, get the title of the module too
			switch ($task->extension) {
				case "com_modules":
					// look up title in the modules table
					$q="select title from #__modules where id=" . $task->extensionid;
					break;
				case "com_content":
					$q="select title from #__content where id=" . $task->extensionid;
					break;
			}
			
			if($task->id && !$task->details) {
				// somehow a blank task has worked its way in. delete it
				$q="delete from #__wstd_tasklist where id=" . $task->id;
			} else {
				$db->setQuery( $q );
				$itemTitle = $db->loadResult();
				// now write it back to the database
				$q="update #__wstd_tasklist set itemtitle=\"" . $itemTitle . "\" where id=" . $task->id;
			}
			
			$db->setQuery( $q );
			$db->query();
		}
		
	}
}
