<?php
/**
 * Lunarhotel Websitetodo
 * 
 * @package    Lunarhotel Websitetodo
 * @subpackage Components
 * @link http://www.lunarhotel.co.uk
 * @license		GNU/GPL
 */

jimport('joomla.application.component.controller');


class WebsiteToDoController extends JController
{
	/**
	 * Method to display the view
	 *
	 * @access	public
	 */
	function display()
	{
		$this->getModel();
		parent::display();
	}
	
	// unpublish task
	function unpublishTask() {
		
		if( $taskid = JRequest::getVar( "id", false) ) {
	
			$model = $this->getModel("window");
			$model->unPublishTask( $taskid );
		}
	}
	
	// complete task
	function completeTask() {
		
		if( $taskid = JRequest::getVar( "id", false) ) {
			$completedby= JRequest::getVar("completedby", false);
			$model = $this->getModel("window");
			$model->completeTask( $taskid );
		}
	}
	
	function unCompleteTask() {
		if( $taskid = JRequest::getVar( "id", false) ) {
			$model = $this->getModel("window");
			$model->completeTask( $taskid ,false );
		}
	}
	
	function updateTask() {
		$details= JRequest::getVar("details",false);
		
		JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR . DS . "tables");
		$table = JTable::getInstance("websitetodo","Table");
		
		$id=JRequest::getInt("id",false);
		// now load the record
		$table->load ($id);
		// now update the field
		$table->details=$details;
		if( $table->check() ) {
			$table->store();
		}
	}
	
	function addTask() {

		$taskdetails = JRequest::getVar("details",false);
		if($taskdetails) {
			// these are the acceptible delimiters
			$delimiters = array( "\n",";" );
			// url decode it
			$taskdetails = urldecode( $taskdetails );
			
			$extension = urldecode( JRequest::getVar("extension",false) );
			
			$extensionid = JRequest::getVar("extensionid",false);
			
			
			if( $this->strpos_arr( $taskdetails, $delimiters ) ) {
				// ok so lets try splitting on either
				$regexp="/(" . implode( "|" , $delimiters ). ")/";
				$tasks = preg_split($regexp, $taskdetails); 
				// so now we have a list, add them to the table
			} 
			
			if(!is_array($tasks)) {
				// probably just one line has been submitted, with no delimiter
				$tasks=Array ( $taskdetails );
			}
				JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR . DS . "tables");
				
				foreach($tasks as $task) {
					// dont add blank tasks
					if( $task ) {
						// will want to split the input on carraige returns or ;
						$table = JTable::getInstance("websitetodo","Table");
						
						$table->reset();
						
						$table->set( 'details' , trim($task) );

						$table->set( 'extension' , $extension);

						$table->set( 'extensionid' , $extensionid);
						
						if( $table->check() ) {
							if(!$table->store()) {
								die( "store error: " .  $table->getError() );
							}
							
						} else {
							die( "check error: " . $table->getError() );
						}
						unset($table);
					}
				}
		}
		
		$this->display();
	}
	
	// strpos that takes an array of values to match against a string
	// note the stupid argument order (to match strpos)
	function strpos_arr($haystack, $needle) {
		if(!is_array($needle)) $needle = array($needle);
		foreach($needle as $what) {
			if(($pos = strpos($haystack, $what))!==false) return $pos;
		}
		return false;
	}

}
?>
