<?php
/**
 * Lunarhotel Websitetodo
 * 
 * @package    Lunarhotel Websitetodo
 * @subpackage Components
 * @link http://www.lunarhotel.co.uk
 * @license		GNU/GPL
 */

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the Websitetodo Component (this view provides the contents of the popup)
 *
 * @package    Lunarhotel Websitetodo
 * @subpackage Components
 */
class WebsiteTodoViewWindow extends JView
{
	function display($tpl = null)
	{
		// any javascript will have to be included by the system plugin
		$model=$this->getModel();
			
		/* put something in here that checks the url for filtering of the task list*/

		$id=JRequest::getInt("id",false);
		
		$extensionid = JRequest::getVar("extensionid",false);
		$extension = JRequest::getVar("extension",false);
		
		// worst case, we end up with all tasks
		$tasklist=$model->getTaskList($id, $extension, $extensionid);
		$this->assignRef( "tasks", $tasklist);
		$this->assignRef( "extensionid", $extensionid);
		$this->assignRef( "extension", $extension);
		
		// so the add tab shows up if there are no tasks,
		// and the task list shows if there are
		$this->assign("defaultTab",2);
		
		if($id) {
			// we just want to show a specific task instance
			// return all of the window html?
			
			// we know which task we want, so get it
			$task = $model->getTaskList( $id );
			
			if( count($task) ) {
				$this->assignRef("task", $task[0]);
			} else {
				$this->assignRef("tasks", $task);
			}
		} 
		if(!$tasklist && !$task) {
			$this->assign("defaultTab",1);
		} 
		
		
		/*$wlayout = JRequest::getVar("wlayout","default");
		$this->setLayout( $wlayout );*/
		// the task layout name needs to change, depending on whether its default
		// or default_tasks, so
		$tasklayout = ($this->getLayout()=="default") ? "tasks_task" : "task";
		$this->assign("tasklayout", $tasklayout);
		
		
		// now get the component parameters so we know which functions to show etc..
		
		$params = &JComponentHelper::getParams( 'com_websitetodo' );

		$this->assignref("parameters", $params->_registry['_default']['data'] );
		//die(print_r($params, true));
		
		
		
		// display the container
		parent::display($tpl);
		
	}
}
?>
