<?php
/**
* @version		$Id: Dylans plugin to allow a task window to be shown on various items $
* @package		None
* @copyright	Copyright (C) 2011 Dylan J Humphreys. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* 
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

require_once(JPATH_ADMINISTRATOR . DS . "components" . DS . "com_websitetodo" . DS . "helpers" . DS . "websitetodo.php");

/**
 * override the module html renderer.
 */
class  plgSystemwebsitetodo extends JPlugin
{
	function __construct(& $subject, $config) {
		parent::__construct($subject, $config);
		
		global $mainframe;
		// will need to get component parameters here
		// probably using the component helper
		
		// gets these values also in AfterDispatch()
		/*$enabled=true;
		$enableModules=true;*/
		
		
		$JApplication=JFactory::getApplication();
		
		// now lets see by what means we decide if the todo list icons are shown, and if so, if its
		// appropriate to show them according to the component parameters
		
		// first get the component parameters. (so we know where to show the popup if at all!)
		
		if(!$JApplication->isAdmin()) {
			$params =& $mainframe->getParams ('com_websitetodo');
			$enabled = $params->get('enabled');
		}
		
		
		
		//if($enabled && $enableModules) {
		if(iShouldShowTaskIcon("com_modules")) {
			$lang =& JFactory::getLanguage();
			
			//$value = $this->params->get("someparam",false));
			
			$document	= &JFactory::getDocument();
			
			

			if ( is_a( $document ,"JDocumentHTML" )  && !$JApplication->isAdmin()) {
				$options = array (
					'charset'	=> 'utf-8',
					'lineend'	=> 'unix',
					'tab'		=> '  ',
					'language'	=> $lang->getTag(),
					'direction'	=> $lang->isRTL() ? 'rtl' : 'ltr'
				);
				
				require_once( JPATH_ROOT . DS . "plugins" . DS . 
					"system" . DS . "websitetodo" . DS . "html.php" );
				
				$document = new LHJDocumentHTML ($options) ;
				//define new document object
				
			}
		}
		
		// now add the js script, and css that we'll need
		if($enabled) {
			if(!$document) {$document=&JFactory::getDocument();}
			$document->addScript (JURI::base(true) . "plugins/system/websitetodo/popup-window.js");
			$document->addScript (JURI::base(true) . "components/com_websitetodo/assets/ajax.js");
			$document->addScript (JURI::base(true) . "components/com_websitetodo/assets/websitetodo.js");
			$document->addStyleSheet (JURI::base(true) . "plugins/system/websitetodo/wstd-styles.css");
			$document->addStyleSheet (JURI::base(true) . "components/com_websitetodo/assets/lhtabs.css");
			$document->addScript (JURI::base(true) . "components/com_websitetodo/assets/lhtabs.js");
		}
		
		
	}
	
	function onAfterDispatch() {
		// gets these values also in AfterDispatch()
		$enabled=true;
		$enableModules=true;
		$enableContent=true;
		
		
		// will need to get component parameters here
		$JApplication=JFactory::getApplication();
		global $mainframe;
		
		if(!$JApplication->isAdmin()) {
			$params =& $mainframe->getParams ('com_websitetodo');
			$enabled = $params->get('enabled');
			$enableModules=$params->get('enableModules');
			$enableContent= $params->get('enableContent');
			$showOnUserid= $params->get('userId');
		}
		
		
		
		$JApplication=JFactory::getApplication();
		
		if( $enabled && !$JApplication->isAdmin() ) {
			// need to add the popup code to the component output but only if its not us!
			
			$document	= &JFactory::getDocument();
			$buffer = $document->getBuffer ("component", "" , "");
			
			
			if(JRequest::getVar("option",false)!="com_websitetodo") {
				// this is the html that makes up the popup frame (header bar, main body etc)
				// module helper then adds an icon to each module so that when clicked, the window
				// can be shown. 
				$popuphtml='<div class="sample_popup" id="popup" style="display: none;">

								<div class="menu_form_header" id="popup_drag">
								<img class="menu_form_exit"   id="popup_exit" src="' . JURI::base(true) . DS . "plugins" . DS . 
								 "system" . DS . "websitetodo" . DS . "close.png" . '" alt="" />
								<span id="popup_title">Title</span>
								</div>

								<div class="menu_form_body" id="wstdbody">
								' . JText::_("TASK LIST LOADING") . '
								</div>

								</div>';

				$buffer = $popuphtml . $buffer;
				$document->setBuffer ($buffer, "component");
				
				// now add tool tip support
				JHTML::_('behavior.tooltip');
				
			}
		}
	}
}