<?php
/**
* @version		$Id: lh overridden modulehelper.php lh $
* @package		Websitetodo
* @copyright	Copyright (C) 2005 - 2011 Lunarhotel.co.uk.
* @license		GNU/GPL, see LICENSE.php
*/

// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();


/**
 * Module helper class. modified to allow low level stuff with modules
  */
class LHJModuleHelper extends JModuleHelper
{

	function renderModule($module, $attribs = array())
	{
		static $chrome;
		global $mainframe, $option;

		$scope = $mainframe->scope; //record the scope
		$mainframe->scope = $module->module;  //set scope to component name

		// Handle legacy globals if enabled
		if ($mainframe->getCfg('legacy'))
		{
			// Include legacy globals
			global $my, $database, $acl, $mosConfig_absolute_path;

			// Get the task variable for local scope
			$task = JRequest::getString('task');

			// For backwards compatibility extract the config vars as globals
			$registry =& JFactory::getConfig();
			foreach (get_object_vars($registry->toObject()) as $k => $v) {
				$name = 'mosConfig_'.$k;
				$$name = $v;
			}
			$contentConfig = &JComponentHelper::getParams( 'com_content' );
			foreach (get_object_vars($contentConfig->toObject()) as $k => $v)
			{
				$name = 'mosConfig_'.$k;
				$$name = $v;
			}
			$usersConfig = &JComponentHelper::getParams( 'com_users' );
			foreach (get_object_vars($usersConfig->toObject()) as $k => $v)
			{
				$name = 'mosConfig_'.$k;
				$$name = $v;
			}
		}

		// Get module parameters
		$params = new JParameter( $module->params );

		// Get module path
		$module->module = preg_replace('/[^A-Z0-9_\.-]/i', '', $module->module);
		$path = JPATH_BASE.DS.'modules'.DS.$module->module.DS.$module->module.'.php';

		// Load the module
		if (!$module->user && file_exists( $path ) && empty($module->content))
		{
			$lang =& JFactory::getLanguage();
			$lang->load($module->module);

			$content = '';
			ob_start();
			require $path;
			$module->content = ob_get_contents().$content;
			ob_end_clean();
		}

		// Load the module chrome functions
		if (!$chrome) {
			$chrome = array();
		}

		require_once (JPATH_BASE.DS.'templates'.DS.'system'.DS.'html'.DS.'modules.php');
		$chromePath = JPATH_BASE.DS.'templates'.DS.$mainframe->getTemplate().DS.'html'.DS.'modules.php';
		if (!isset( $chrome[$chromePath]))
		{
			if (file_exists($chromePath)) {
				require_once ($chromePath);
			}
			$chrome[$chromePath] = true;
		}

		//make sure a style is set
		if(!isset($attribs['style'])) {
			$attribs['style'] = 'none';
		}

		//dynamically add outline style
		if(JRequest::getBool('tp')) {
			$attribs['style'] .= ' outline';
		}
		//['data']['moduleclass_sfx'] = " wstd_mod"
		$params->_registry['_default']['data']->moduleclass_sfx .=  " wstd_mod";
		

		foreach(explode(' ', $attribs['style']) as $style)
		{
			$chromeMethod = 'modChrome_'.$style;

			// Apply chrome and render module
			if (function_exists($chromeMethod))
			{
				$module->style = $attribs['style'];

				ob_start();
				$chromeMethod($module, $params, $attribs);
				$module->content = ob_get_contents();
				ob_end_clean();
			}
		}

		$mainframe->scope = $scope; //revert the scope
		
		// also, dont want to tag things in admin
		$JApplication=JFactory::getApplication();
		
		
		$showWstd=false;
		
		// code to test if we should show the add task icon
		$showwstd_method=1;
		
		switch($showwstd_method) {
			case 1: // always on
				$showWstd=true;
				break;
			case 2:
				// get which user it should be shown for
				$showWstd_user=104; // get this from component parameters
				// now find out which (if any) user is logged in
				$curuser=JFactory::getUser();
				$showWstd=($curuser->id==$showWstd_user);
				break;
		}
				
		
		
		
		if(!$JApplication->isAdmin() && $showWstd) {
			// put in an exclusion list, so that we can exclude certain modules / components from getting tagged
			if($module->module!="mod_metamod") {
				// this html defines how the icon looks, and what parameters are set for the 
				// window, including the windows title, and the module id it will be storing
				// tasks for. This is passed to the popup_show in popup-window.js in 
				// /plugins/system/websitetodo
				// popup_show then does an ajax call passing the module id, and the extension id
				
				// just the normal "i" tag with onclick event
				$prehtml="<div class=\"wstd_tagcontainer\" id=\"module" . $module->id . "\">
					<img class=\"wstd_image hasTip\" src=\"/plugins/system/websitetodo/tag.png\" 
					onclick=\"popup_show('popup', 'popup_drag', 'popup_exit', 
					'mouse',-10, -10, '','Module [" . str_replace("'","",$module->title )  
					. "]','com_modules'," . $module->id . ");\" title=\"" . JText::_("Module") . ": " . $module->title . "::Click here to add tasks\"/></div>";
				
				
				// encompassing div with red border around module on hover, and popup launch on double click
				
				$posthtml="";
				
			}
		}
		
		
		return  $prehtml . $module->content . $posthtml;
	}
	
	function sanitiseTitle($title) {
		return str_replace("'","",$title);
	}
}

